//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Variable-width multiplier made strictly out of AND Gates and adders according to the multiplication algorithm.
//Sub-module: Parallel multiplier stage
//Care must be taken when reading the result due to the considerable delay of the array when using large widths.
//Version 2.0
//Date: 7-Feb-2011
//Written by: Jose Pablo Pinilla
//Investigation Group: Advanced Digital Technologies (ADT)
//Universidad Pontificia Bolivariana Seccional Bucaramanga, Colombia
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////

module multiplier_stage# (parameter WIDTH = 4) (A,B,stagein,stage);

input [WIDTH-1:0]A;
input B;
input [WIDTH:0]stagein;
output [WIDTH:0]stage;

wire 	[WIDTH-1:0]Cout;
wire	[WIDTH-1:0]result;

genvar j;

generate
	for (j=0; j<WIDTH; j=j+1) 

		begin: ADDER
			if (j==0)
				adderC adder1 (.Cin(1'b0), .Sum1(A[j] & B), .Sum2(stagein[1]), .Result(result[0]), .Cout(Cout[0]));
			else
				adderC adder_gen(.Cin(Cout[j-1]), .Sum1(A[j] & B), .Sum2(stagein[j+1]), .Result(result[j]), .Cout(Cout[j]));
				
			assign stage[j] = result[j];
			assign stage[WIDTH] = Cout[WIDTH-1];
		end

endgenerate

endmodule
