//===================================RISCKER====================================
//===================================Rotate=====================================
//------------------------------------------------------------------------------
//File Name:	rotate.v
//Purpose:		Rotate function mux stages generate loop instantiation
//Parameters:	w (data width) s (shift amount)
//------------------------------------------------------------------------------
//=====================Alfredo Gualdron - Jose P. Pinilla=======================
//=================================Semillero ADT================================
//================================UPB Bucaramanga===============================
//Website:	http://semilleroadt.upbbga.edu.co/xiscker
//E-mail:	semilleroadt@gmail.com
//------------------------------------------------------------------------------
module rotate # (parameter w=16, s=4) (rin, rout, shamt);

	input [w-1:0] rin;
	output [w-1:0] rout;
	input [s-1:0] shamt;

genvar i;

generate 
		for (i=0; i<w; i=i+1)
				begin:Rotate_Shift
					
					if (i==w-1)	begin
						wire [w-1:0] path=rin;
						mux  mux_4	(.a(path), .y(rout[i]), .sh(~shamt));
						end
					else begin
						wire [w-1:0] path1={{rin[i:0]},{rin[(w-1):(i+1)]}};
						mux  mux_4	(.a(path1), .y(rout[i]), .sh(~shamt));
						end
					
				end
		
endgenerate


endmodule

